//+------------------------------------------------------------------+
//|                                 Shinigami BykovTrend EA v1.3.mq4 |
//|                                                     by Shinigami |
//|                                              Shini1984@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Shinigami"
#property link      "Shini1984@gmail.com"

extern string EAParams = "EA parameters";
extern double Lots = 0.1;
extern int TP = 0;
extern int SL = 0;
extern int Slippage = 3;
extern int TS = 0;
extern int MN = 1010141;

extern string IndiParams = "Indicator parameters";
extern int RISK=3;
extern int SSP=9;

int recheck=0;
datetime now=0;

//+====================================================================================+
int start()
{
RefreshRates();
int signal=0,type=-1,buys=0,sells=0,old=0,new=0;
double b=NormalizeDouble(Bid,Digits),a=NormalizeDouble(Ask,Digits),p=Point,d=Digits;
double indi0=0,indi1=0,indi2=0,indi3=0;
int K=0; double wpr=0;

// indicator signal check
if(Time[0]!=now) {
wpr=iWPR(NULL,0,SSP,1);
K=33-RISK;
if(wpr<-100+K) signal=-1;
if(wpr>-K) signal=1;
if(wpr>=-100+K&&wpr<=-K) signal=0;
recheck++;
if(recheck>6) { recheck=0; now=Time[0]; }
}
//end of indicator signal check

if(signal!=0) {
for(int i=0;i<=OrdersTotal();i++) {
if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
if(OrderSymbol()!=Symbol()) continue;
if(OrderMagicNumber()!=MN) continue;
type=OrderType();
if(signal==1) {
 if(type==OP_BUY) buys++;
 if(type==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),a,Slippage); Sleep(1000); } }
if(signal==-1) {
 if(type==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),b,Slippage); Sleep(1000); }
 if(type==OP_SELL) sells++; }
type=-1;
} }

if(signal==1&&buys==0) { if(Hist(OP_BUY)==0) { if(Last(OP_BUY)==0) {
 OrderSend(Symbol(),OP_BUY,Lots,a,Slippage,0,0,NULL,MN);
 Sleep(1000); return(0); } } }
if(signal==-1&&sells==0) { if(Hist(OP_SELL)==0) { if(Last(OP_SELL)==0) {
 OrderSend(Symbol(),OP_SELL,Lots,b,Slippage,0,0,NULL,MN);
 Sleep(1000); return(0); } } }

if(TP!=0||SL!=0) ModOrders();
if(TS!=0) TrailStop();

int last=GetLastError(); if(last!=0) Print("Error! ",last);
return(0);
}
//+====================================================================================+
int ModOrders()
{
RefreshRates();
if(OrdersTotal()==0) return(0);
double p=Point,d=Digits,tp=0,sl=0,open=0;
int type=-1;
for(int i=0;i<=OrdersTotal();i++) {
if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
if(OrderSymbol()!=Symbol()) continue;
if(OrderMagicNumber()!=MN) continue;
open=NormalizeDouble(OrderOpenPrice(),d);
tp=NormalizeDouble(OrderTakeProfit(),d);
sl=NormalizeDouble(OrderStopLoss(),d);
type=OrderType();
if(type==OP_BUY) {
if(TP!=0&&tp==0) {
  if(SL!=0&&sl==0) { 
       OrderModify(OrderTicket(),OrderOpenPrice(),open-SL*p,open+TP*p,0);
       open=0;sl=0;tp=0;type=-1; }
  if(sl!=0||SL==0) { 
       OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),open+TP*p,0);
       open=0;sl=0;tp=0;type=-1; } }
if(sl==0&&SL!=0) {
       OrderModify(OrderTicket(),OrderOpenPrice(),open-SL*p,OrderTakeProfit(),0);
       open=0;sl=0;tp=0;type=-1; } }
if(type==OP_SELL) {
if(tp==0&&TP!=0) {
  if(sl==0&&SL!=0) { 
       OrderModify(OrderTicket(),OrderOpenPrice(),open+SL*p,open-TP*p,0);
       open=0;sl=0;tp=0;type=-1; }
  if(sl!=0||SL==0) {
       OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),open-TP*p,0);
       open=0;sl=0;tp=0;type=-1; } }
if(sl==0&&SL!=0) {
       OrderModify(OrderTicket(),OrderOpenPrice(),open+SL*p,OrderTakeProfit(),0);
       open=0;sl=0;tp=0;type=-1; } }
}
int last=GetLastError(); if(last!=0) Print("Error! ",last);
return(0);
}
//+====================================================================================+
int TrailStop()
{
RefreshRates();
if(OrdersTotal()==0) return(0);
double p=Point,d=Digits,tp=0,sl=0,open=0,a=NormalizeDouble(Ask,Digits),b=NormalizeDouble(Bid,Digits),
       stoplvl=NormalizeDouble(MarketInfo(Symbol(),MODE_STOPLEVEL)*Point,Digits);
int type=-1;
for(int i=0;i<=OrdersTotal();i++) {
if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
if(OrderSymbol()!=Symbol()) continue;
if(OrderMagicNumber()!=MN) continue;
open=NormalizeDouble(OrderOpenPrice(),d);
sl=NormalizeDouble(OrderStopLoss(),d);
type=OrderType();
if(type==OP_BUY) {
if(b-TS*p>sl+stoplvl&&b-TS*p>open+stoplvl)
   OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(b-TS*p,d),OrderTakeProfit(),0); }
if(type==OP_SELL) {
if(a+TS*p<sl-stoplvl&&a+TS*p<open-stoplvl)
   OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(a+TS*p,d),OrderTakeProfit(),0); }
}
int last=GetLastError(); if(last!=0) Print("Error! ",last);
return(0);
}
//+====================================================================================+
int Hist(int type)
{
RefreshRates();
if(OrdersHistoryTotal()==0) return(0);
int result=0;
for(int i=0;i<=OrdersHistoryTotal();i++) {
if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) continue;
if(OrderSymbol()!=Symbol()) continue;
if(OrderMagicNumber()!=MN) continue;
if(OrderType()==type&&OrderOpenTime()>Time[0]) result++;
}
int last=GetLastError(); if(last!=0) Print("Error! ",last);
return(result);
}
//+====================================================================================+
int Last(int type)
{
RefreshRates();
if(OrdersHistoryTotal()==0) return(0);
datetime last,time;
int result=0,idlast=-1;
for(int i=0;i<=OrdersHistoryTotal();i++) {
if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) continue;
if(OrderSymbol()!=Symbol()) continue;
if(OrderMagicNumber()!=MN) continue;
time=OrderOpenTime();
if(time!=0&&(time>last||last==0)) { last=time; idlast=OrderTicket(); }
}

if(OrderSelect(idlast,SELECT_BY_TICKET,MODE_HISTORY)) {
if(OrderType()==type) return(1);
if(OrderType()!=type) return(0); }
if(!OrderSelect(idlast,SELECT_BY_TICKET,MODE_HISTORY)) return(1);

int lazt=GetLastError(); if(lazt!=0) Print("Error! ",lazt);
return(0);
}
//+====================================================================================+
//+====================================================================================+
//+====================================================================================+
//+====================================================================================+
//+====================================================================================+
//+====================================================================================+
//+====================================================================================+
//+====================================================================================+
//+====================================================================================+
//+====================================================================================+
//+====================================================================================+

